%UI interface for temperature controller

clf
clear all
try
    fclose(instrfind) %close any bogus serial connections
end

%set(gcf,'CloseRequestFcn','delete')


%define the plot button
start_button=uicontrol('style','pushbutton',...
   'string','Start', ...
   'fontsize',12, ...
   'position',[100,400,60,20], ...
   'callback', 'start=1;');

%define the detection button
detect_button=uicontrol('style','pushbutton',...
   'string','detect', ...
   'fontsize',12, ...
   'position',[200,400,50,20], ...
   'callback','detect=1;');


%define non-editable text field for showing current temperature 
current_temperature=uicontrol('style','text',...
   'string','', ...
   'fontsize',12, ...
   'position',[220,1,100,40]...
   );

%define edibale text file for inputing desired temperature
desired_temperature=uicontrol('style','edit',...
   'string','0', ...
   'fontsize',12, ...
   'position',[100,1,100,40] ...
      );

%define edibal text field for setting communication port
communication_ports_set=uicontrol('style','edit',...
   'string','COM1', ...
   'fontsize',12, ...
   'position',[400,1,100,40] ...
      );
  
 %define the set button
setbutton=uicontrol('style','pushbutton',...
   'string','Set', ...
   'fontsize',12, ...
   'position',[500,1,50,20], ...
   'callback','set_C=1;'); 
  
  
  

%define the quit button
quitbutton=uicontrol('style','pushbutton',...
   'string','Quit', ...
   'fontsize',12, ...
   'position',[500,400,50,20], ...
   'callback','quit=1;close;');

%define the stop button
stop_button=uicontrol('style','pushbutton',...
   'string','stop', ...
   'fontsize',12, ...
   'position',[300,400,50,20], ...
   'callback','stop=1;');





%make some axes
axeshandle = axes(...
   'position',[.2 .2 .7 .7],...
   'xlim',[0 100],...
   'ylim',[-20 60]);

%initiate button signals
quit=0; %wait for a quit button push
set_C=0;
start=0; 
plus = 1;
neg = 0;
detect =0; 
stop =0; %wait for a stop command
setbkgnd=0;
saveit=0;
num_s = 0;
flag = 1;
%null out x and y
x=[];y=[];
bkgndcolor = [1,1,1];
time = 0;
frame_begin = 0  ;
frame_end   = 100;
frame_limit = 99;



    
while (quit==0)
   pause(1)
   %//////drawnow; %need this in the loop for controls to work

   if ((set_C == 1) && (flag == 1))
     flag = 0
      %=====open a serial connection===============================
      %set its rate to 9600 baud
      %SR830 terminator character is  (ACSII 13)
      %use fprintf(s,['m' mode]) to write
      %and fscanf(s) to read the SR830
     port = get(communication_ports_set,'string');
     s = serial(port,...
        'baudrate',9600,...
        'terminator',13); 
    fopen(s)
   end
     if (flag == 0)
       
       if start==1
          start=0;
          Switch = 0;
            des_temp = 48+str2num(get(desired_temperature,'string'));

          fprintf(s,des_temp)

       end

       if detect==1
            fprintf(s,'s')
            Switch = fscanf(s,'%d%d')
            num_s = Switch(1) + Switch(2)/10;
            plot(time,num_s,'--rs','LineWidth',2,...
                    'MarkerEdgeColor','g',...
                    'MarkerFaceColor','g',...
                    'MarkerSize',2),grid on;

            hold on;
            if(time>frame_limit)
                 frame_begin = frame_begin + 100    ;
                 frame_end   = frame_end + 100      ;
                 frame_limit = frame_limit + 100    ;
            end
            axis([ frame_begin frame_end -20 60]);
            time = time +1;
            
            set(current_temperature,'string',num2str(num_s));

       end

       if stop==1
          stop   = 0;
          detect = 0;
          set(desired_temperature,'string','0');
          set(current_temperature,'string','0');
          fprintf(s,'t')
       end
    end
   
   
   
end
if(flag == 0)
  fclose(s)
end

